[inherit('demo', 'vpunit')]
program testdemo(input, output);

procedure test_add2;

var
    a, b, c : integer;

begin
    a := 123;
    b := 456;
    c := add2(a, b);
    vpunit_check_integer_equals(579, c, 'add2(123, 456)');
end;

procedure test_sub2;

var
    a, b, c : integer;

begin
    a := 579;
    b := 123;
    c := sub2(a, b);
    vpunit_check_integer_equals(456, c, 'sub2(579, 123)');
end;

procedure test_mul2;

var
    a, b, c : integer;

begin
    a := 11;
    b := 12;
    c := mul2(a, b);
    vpunit_check_integer_equals(131, c, 'mul2(11, 12)');
end;

procedure test_div2;

var
    a, b, c : integer;

begin
    a := 50;
    b := 3;
    c := div2(a, b);
    vpunit_check_integer_equals(16, c, 'div2(50, 3)');
end;

procedure test_alwaystrue;

var
    b : boolean;

begin
    b := alwaystrue;
    vpunit_check_true(b, 'alwaystrue');
end;

procedure test_dup;

var
    s, s2 : varstr;

begin
    s := 'ABC';
    s2 := dup(s);
    vpunit_check_fixstring_equals('ABCABC', s, 'dup(''ABC'')');
end;

begin
    vpunit_test(test_add2); 
    vpunit_test(test_sub2); 
    vpunit_test(test_mul2); 
    vpunit_test(test_div2); 
    vpunit_stats;    
end.
