module vpunit(input, output);

type
    varstr = varying[32000] of char;

var
    total : integer value 0;
    fail : integer value 0;
    check : boolean;

procedure vpunit_check_integer_equals(expected, actual : integer; message : packed array [$l1..$u2:integer] of char);

begin
    if expected <> actual then begin
        writeln('Failure: expected ', expected:1, ' actual ', actual:1, ' for ', message);
        check := false;
    end else begin
        check := true;
    end;
end;

procedure vpunit_check_fixstring_equals(expected :  packed array [$l1..$u1:integer] of char; actual :  packed array [$l2..$u2:integer] of char; message : packed array [$l3..$u3:integer] of char);

begin
    if expected <> actual then begin
        writeln('Failure: expected ', expected, ' actual ', actual, ' for ', message);
        check := false;
    end else begin
        check := true;
    end;
end;

procedure vpunit_check_varstring_equals(expected : varstr; actual : varstr; message : packed array [$l3..$u3:integer] of char);

begin
    if expected <> actual then begin
        writeln('Failure: expected ', expected, ' actual ', actual, ' for ', message);
        check := false;
    end else begin
        check := true;
    end;
end;

procedure vpunit_check_true(expression : boolean; message : packed array [$l1..$u2:integer] of char);

begin
    if not expression then begin
        writeln('Failure: expected true actual false for ', message);
        check := false;
    end else begin
        check := true;
    end;
end;

procedure vpunit_check_notnil(p : pointer; message : packed array [$l1..$u2:integer] of char);

begin
    if p <> nil then begin
        writeln('Failure: expected not nil actual nil for ', message);
        check := false;
    end else begin
        check := true;
    end;
end;

procedure vpunit_test(procedure tst);

begin
    total := total + 1;
    tst;
    if not check then fail := fail + 1;
end;

procedure vpunit_stats;

begin
    writeln(total:1, ' tests run: ', fail:1, ' failed');
end;

end.
